<template>
  <div>
    <!--引用表格-->
   <BasicTable @register="registerTable" :rowSelection="rowSelection">
     <!--插槽:table标题-->
      <template #tableTitle>
          <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined">手动添加</a-button>
          <!-- <a-button  type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
          <j-upload-button  type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button> -->
          <a-button type="primary" @click="handleShowDrawer" preIcon="ant-design:plus-outlined">从第三方库添加</a-button>
          <a-dropdown v-if="selectedRowKeys.length > 0">
              <template #overlay>
                <a-menu>
                  <a-menu-item key="1" @click="batchHandleDelete">
                    <Icon icon="ant-design:delete-outlined"></Icon>
                    删除
                  </a-menu-item>
                </a-menu>
              </template>
              <a-button>批量操作
                <Icon icon="mdi:chevron-down"></Icon>
              </a-button>
        </a-dropdown>
      </template>
       <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <WbSurveyCfgModal @register="registerModal" @success="handleSuccess"></WbSurveyCfgModal>
    <a-drawer
          title="设置关系"
          placement="right"
          width="80%"
          :closable="true"
          :visible="showDrawer"
          :get-container="false"
          :body-style="{ padding: '0px',margin:'0px',overflow: 'hidden'}"
          @close="onClose"
      >
          <WbSurveyCfgSetIndex  ref="regWbSurveyCfgSetIndex" @success="saveSuccess"></WbSurveyCfgSetIndex>
   
      </a-drawer>

  </div>
</template>

<script lang="ts" name="wb.survey-wbSurveyCfg" setup>
  import {ref, computed, unref} from 'vue';
  import {BasicTable, useTable, TableAction} from '/@/components/Table';
  import {useModal} from '/@/components/Modal';
  import { useListPage } from '/@/hooks/system/useListPage'
  import WbSurveyCfgModal from './components/WbSurveyCfgModal.vue'
  import {columns} from './WbSurveyCfg.data';
  import {list, deleteOne, batchDelete, getImportUrl,getExportUrl} from './WbSurveyCfg.api';

  import WbSurveyCfgSetIndex from './components/WbSurveyCfgSetIndex.vue'
  const checkedKeys = ref<Array<string | number>>([]);

  const showDrawer = ref(false);
  const regWbSurveyCfgSetIndex = ref();
   
  const domainCode = ref("-1");  
  const domainName  =ref();
  //注册model
  const [registerModal, {openModal}] = useModal();
  //注册table数据
  const { prefixCls,tableContext,onExportXls,onImportXls } = useListPage({
      tableProps:{
           title: '调查配置',
           api: list,
           columns,
           canResize:false,
           useSearchForm:false,
           actionColumn: {
               width: 120,
               fixed:'right'
          },
       
          beforeFetch(params) {
            params['domainCode'] = domainCode.value
            params = Object.assign(params)  
          },
          defSort :{
            column: 'id',
            order: 'desc',
          },
      },

      exportConfig: {
        name:"调查配置",
        url: getExportUrl,
      },
      importConfig: {
        url: getImportUrl,
        success: handleSuccess
      },
  })

  const [registerTable, {reload},{ rowSelection, selectedRowKeys }] = tableContext

   /**
    * 新增事件
    */
  function handleAdd(record: Recordable) {
     record.domainCode=domainCode.value
     record.domainName=domainName.value
     record.tp=1
     openModal(true, {
       record,
       isUpdate: false,
       showFooter: true,
     });
  }
   /**
    * 编辑事件
    */
  function handleEdit(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: true,
     });
   }
   /**
    * 详情
   */
  function handleDetail(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }
   /**
    * 删除事件
    */
  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
   /**
    * 批量删除事件
    */
  async function batchHandleDelete() {
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
   }
   /**
    * 成功回调
    */
  function handleSuccess() {
      (selectedRowKeys.value = []) && reload();
   }
   /**
      * 操作栏
      */
  function getTableAction(record){
       return [
         {
           label: '编辑',
           onClick: handleEdit.bind(null, record),
         }
       ]
   }
     /**
        * 下拉操作栏
        */
  function getDropDownAction(record){
       return [
         {
           label: '详情',
           onClick: handleDetail.bind(null, record),
         }, {
           label: '删除',
           popConfirm: {
             title: '是否确认删除',
             confirm: handleDelete.bind(null, record),
           }
         }
       ]
   }

   
   async function setData(data) {
        //await setFieldsValue(data);
    }
    
    async function getData() {
        // let values = await validate();   
        // return values;
    }

    async function setDomain(code,name) {
      domainCode.value = code
      domainName.value = name
      reload();
    }

    const onClose = () => {
      showDrawer.value = false;
    
    };

    const handleShowDrawer = () => {
      showDrawer.value = true;
      regWbSurveyCfgSetIndex.value.setData(domainCode.value,domainName.value); 
    };

    const saveSuccess = () => {
      (selectedRowKeys.value = []) && reload();
      onClose();
    };

    defineExpose({
        setData,
        setDomain,
        getData,
    });

</script>

<style scoped>

</style>